# coding: utf-8
import json
import argparse
import sys; sys.path.append('./')
from tools.utils import *
from tools.retriever import *

from run_source.evaluate import *
from models import *

from algos.rewoo import *
from algos.react import *
from algos.ours import *

# define four tasks
# task_1 = retrieve_external_knowledge(query, knowlegde_bases)
# task_2 = generate_internal_knowledge(query)
# task_3 = is_suffient_to_answer(query, knowledge)
# task_4 = decompose(query, known)

if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument("--dataset", type=str, default="focus", help="the name of dataset")
    parser.add_argument('--model', type=str, default='ours', choices=['cot', 'chameleon', 'rewoo', 'react', 'ours'])
    parser.add_argument('--label', type=str, default='chameleon_chatgpt')
    parser.add_argument("--model_type", type=str, default="gpt-3.5-turbo-0613", help="the models used including chatglm-6b, chatgpt, flan-t5, flan-ul2")
    parser.add_argument("--model_path", type=str, default="", help="the path of stored pre-trained model")
    parser.add_argument("--retriever_type", type=str, default="bm25", help="the type of different retriever to retrieve")
    parser.add_argument("--retriever_number", type=int, default=1, help="the number of middle results for each sources")
    parser.add_argument("--setting", type=str, default="in-context", help="the settings of the exp including zero-shot and one-shot")
    parser.add_argument("--lang", type=str, default="english", help="the language of datasets and prompts")
    args = parser.parse_args()

    # 密钥文件路径，填入分配的密钥
    key_path = 'conf/mine_keys.txt'

    # 初始化plan dialogue system 和 数据集
    if args.dataset == "focus":
        if args.model == "cot":
            adaptive_ds = CoT(key_path, args.dataset, model_type=args.model_type, model_path=args.model_path, language=args.lang, setting=args.setting, temperature=0., persona="", top_p=0.1)
            adaptive_ds.predict_responses()
        elif args.model == "chameleon":
            adaptive_ds = Chameleon(key_path, args.dataset, model_type=args.model_type, model_path=args.model_path, language=args.lang, setting=args.setting, temperature=0., persona="", top_p=0.1)
            adaptive_ds.predict_responses()
        elif args.model == "react":
            adaptive_ds = ReAct(key_path, args.dataset, model_type=args.model_type, model_path=args.model_path, language=args.lang, setting=args.setting, temperature=0., persona="", top_p=0.1)
            adaptive_ds.predict_responses()
        elif args.model == "rewoo":
            adaptive_ds = ReWOO(key_path, args.dataset, model_type=args.model_type, model_path=args.model_path, language=args.lang, setting=args.setting, temperature=0., persona="", top_p=0.1)
            adaptive_ds.predict_responses()
        elif args.model == "ours":
            adaptive_ds = ThinkPlanDo(key_path, args.dataset, model_type=args.model_type, model_path=args.model_path, language=args.lang, setting=args.setting, temperature=0., persona="", top_p=0.1)
            adaptive_ds.predict_responses()    